classdef Model < handle
    %UNTITLED2 Summary of this class goes here
    %   Detailed explanation goes here
    
    properties (Abstract)
        Name        % String name for model class
        Dimension   % Number of variables in model
        NumPars     % Number of parameters in model
        NumFreePars % Number of freely varying parameters
    end
    
    properties (Access = private)
       Pars        % Parameters of the model (double, struct or object)
    end
    
    methods (Abstract)
        % general function
        estimate(this)
        data = generate(this)
        % setters
        setPars(this) 
        setData(this)
        % getters
        [pars] = getPars(this)
        [vP]   = getVectorPars(this)
        [vP]   = getVectorFreePars(this)
    end    
end

